var grammar = {
	'value': [
		['object'],
		['array'],
		['string'],
		['number'],
		['atom'],
	],
	'object': [
		['{', 'string', ':', 'value', 'object-tail']
	],
	'object-tail': [
		[',', 'string', ':', 'value', 'object-tail'],
		['}']
	],
	'array': [
		['[', 'value', 'array-tail']
	],
	'array-tail': [
		[',', 'value', 'array-tail'],
		[']']
	]
};

var non_terminals = ['value', 'object', 'array', 'object-tail', 'array-tail'];

var guess = function(guess_node, tokens, start) {
	if (tokens[start].type === guess_node) { // token already matches
		return true
	}
	if (grammar[guess_node] === undefined) { // token doesn't match and can't be expanded
		return false
	}
	for (var i = 0; i < grammar[guess_node].length; i++) { // look for matching expansion
		var posibility = grammar[guess_node][i];
		if (guess(posibility[0], tokens, start)) { // assume this expansion
			for (var j = 0; j < posibility.length; j++) {
				var node = posibility[j];
				if (! guess(node, tokens, start + j)) {
					return false;
				}
			}
			return true;
		}
	}
	return false;
}

exports.parse = function(tokens) {
	if (guess('value', tokens, 0)) {
		return tokens;
	} else {
		throw 'parse error';
	}
}